//+------------------------------------------------------------------+
//|                                                     Triggerlines |
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

//
//
//
//
//

#property indicator_chart_window
#property indicator_buffers 8            
#property indicator_color1  clrAqua      
#property indicator_color2  clrMagenta
#property indicator_color3  clrMagenta
#property indicator_color4  clrAqua      
#property indicator_color5  clrMagenta
#property indicator_color6  clrMagenta
#property indicator_color7  clrAqua
#property indicator_color8  clrMagenta
#property indicator_width1  2      
#property indicator_width2  2  
#property indicator_width3  2  
#property indicator_width4  2  
#property indicator_width5  2  
#property indicator_width6  2  

//
//
//
//
//

extern int                LsmaPeriod      = 20;
extern ENUM_APPLIED_PRICE LsmaPrice       = 0;
extern bool               alertsOn        = true;
extern bool               alertsOnCurrent = true;
extern bool               alertsMessage   = true;
extern bool               alertsSound     = true;
extern bool               alertsEmail     = false;
extern bool               alertsNotify    = false;
extern int                ArrowCodeUp     = 159;      // Arrow code up
extern int                ArrowCodeDn     = 159;      // Arrow code down
extern double             ArrowGapUp      = 0.5;      // Gap for arrow up        
extern double             ArrowGapDn      = 0.5;      // Gap for arrow down

//
//
//
//
//

double lsma[];
double lsmaUa[];
double lsmaUb[];
double lwma[];
double lwmaUa[];
double lwmaUb[];
double lstrend[];
double lwtrend[];
double arrowu[];
double arrowd[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(11);   
   SetIndexBuffer(0,lsma);
   SetIndexBuffer(1,lsmaUa);
   SetIndexBuffer(2,lsmaUb);
   SetIndexBuffer(3,lwma);
   SetIndexBuffer(4,lwmaUa);
   SetIndexBuffer(5,lwmaUb);
   SetIndexBuffer(6,arrowu);  SetIndexStyle(6,DRAW_ARROW); SetIndexArrow(6,ArrowCodeUp);
   SetIndexBuffer(7,arrowd);  SetIndexStyle(7,DRAW_ARROW); SetIndexArrow(7,ArrowCodeDn);
   SetIndexBuffer(8,lstrend);        
   SetIndexBuffer(9,lwtrend); 
   SetIndexBuffer(10,trend);        
       
   IndicatorShortName("Triggerlines");
 return(0);
}

//
//
//
//
//

int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
    
   //
   //
   //
   //
   //

   if (lstrend[limit]==-1) CleanPoint(limit,lsmaUa,lsmaUb);
   if (lwtrend[limit]==-1) CleanPoint(limit,lwmaUa,lwmaUb);      
   for(i=limit; i>=0; i--)
   {
      lsma[i]    = 3.0 * iMA(NULL,0,LsmaPeriod,0,MODE_LWMA,LsmaPrice,i) - 2.0 * iMA(NULL,0,LsmaPeriod,0,MODE_SMA,LsmaPrice,i);
      lsmaUa[i]  = EMPTY_VALUE;
      lsmaUb[i]  = EMPTY_VALUE;
      lwmaUa[i]  = EMPTY_VALUE;
      lwmaUb[i]  = EMPTY_VALUE;
      arrowu[i]  = EMPTY_VALUE;
      arrowd[i]  = EMPTY_VALUE;
      lwma[i]    = lsma[i+1];
      lstrend[i] = lstrend[i+1]; 
      lwtrend[i] = lwtrend[i+1];
      trend[i]   = trend[i+1];
       
         if (lsma[i] > lsma[i+1]) lstrend[i] =  1;
         if (lsma[i] < lsma[i+1]) lstrend[i] = -1;
         if (lwma[i] > lwma[i+1]) lwtrend[i] =  1;
         if (lwma[i] < lwma[i+1]) lwtrend[i] = -1;
         if (lsma[i] > lwma[i])   trend[i]   =  1;
         if (lsma[i] < lwma[i])   trend[i]   = -1;
         if (lstrend[i]==-1) PlotPoint(i,lsmaUa,lsmaUb,lsma);
         if (lwtrend[i]==-1) PlotPoint(i,lwmaUa,lwmaUb,lwma); 
         if (i<Bars-1 && trend[i]!=trend[i+1])
         {
            if (trend[i] ==  1) arrowu[i] = MathMin(lsma[i],Low[i] )-iATR(NULL,0,15,i)*ArrowGapUp;
            if (trend[i] == -1) arrowd[i] = MathMax(lsma[i],High[i])+iATR(NULL,0,15,i)*ArrowGapDn;
         }
    } 
    
    //
    //
    //
    //
    //
    
    if (alertsOn)
    {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("crossed up");
      else  doAlert("crossed down");       
    }     
return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//+------------------------------------------------------------------+
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Triggerlines ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Triggerlines "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}


